lab_1/urls.py
from django.urls import path
from .views import index, friend_list

urlpatterns = [
    path('', index, name='index'),
    path('friends', friend_list, name='friend_list')
]

lab_2/urls.py
from django.urls import path
from .views import index, xml, json

urlpatterns = [
    path('', index, name='index'),
    path('xml', xml, name='xml'),
    path('json', json, name='json')
]

lab_3/urls.py
from django.urls import path
from .views import index, add_friend

urlpatterns = [
    path('', index, name='index'),
    path('add', add_friend, name='add_friend'),
]

lab_4/urls.py
from django.urls import path
from .views import index, add_note, note_list

app_name = 'lab_4'

urlpatterns = [
    path('', index, name='index'),
    path('add_note', add_note, name='add_note'),
    path('note_list', note_list, name='note_list')
]

praktikum/urls.py
from django.urls import path, re_path, include
from django.contrib import admin

import lab_1.urls as lab_1
from lab_1.views import index as index_lab1

import lab_2.urls as lab_2
from lab_2.views import index as index_lab2

import lab_3.urls as lab_3
from lab_3.views import index as index_lab3

import lab_4.urls as lab_4
from lab_4.views import index as index_lab4

urlpatterns = [
    path('admin/', admin.site.urls),

    path('lab-1/', include(lab_1)),
    re_path(r'^$', index_lab1, name='index'),

    path('lab-2/', include(lab_2)),
    re_path(r'^$', index_lab2, name='index'),

    path('lab-3/', include(lab_3)),
    re_path(r'^$', index_lab3, name='index'),

    path('lab-4/', include(lab_4)),
    re_path(r'^$', index_lab4, name='index')
]

lab_1/models.py
from django.db import models

class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.CharField(max_length=10)
    dob = models.DateField()

lab_2/models.py
from django.db import models

class Note(models.Model):
    to = models.CharField(max_length=10)
    froms = models.CharField(max_length=10)
    title = models.CharField(max_length=30)
    message = models.CharField(max_length=100)

lab_3/models.py
from django.db import models
from django import forms

class Friend(models.Model):
    name = models.CharField(max_length=30)
    npm = models.CharField(max_length=10)
    dob = models.DateField()

    widgets = {
            'dob': forms.DateInput(
                format=('%d/%m/%Y'),
                attrs={'class': 'form-control', 
                       'placeholder': 'Select a date',
                       'type': 'date'  # <--- IF I REMOVE THIS LINE, THE INITIAL VALUE IS DISPLAYED
                      }),
    }

lab_4/models.py
from django.db import models

class Note(models.Model):
    to = models.CharField(max_length=10)
    froms = models.CharField(max_length=10)
    title = models.CharField(max_length=100)
    message = models.TextField()

    def __str__(self):
        return f"{self.to} - {self.title}"

lab_3/forms.py
from django.forms import ModelForm
from django import forms
from .models import Friend

class FriendForm(ModelForm):
    class Meta:
        model = Friend
        fields=['name', 'npm', 'dob']


    widgets = {
            'dob': forms.DateInput(
                format=('%d/%m/%Y'),
                attrs={'class': 'form-control', 
                       'placeholder': 'Select a date',
                       # 'type': 'date'  # <--- IF I REMOVE THIS LINE, THE INITIAL VALUE IS DISPLAYED
                      }),
    }

lab_4/forms.py
from django.forms import ModelForm
from .models import Note

class NoteForm(ModelForm):
    class Meta:
        model = Note
        fields = ['to', 'froms', 'title', 'message']


  

lab_1/views.py
from django.shortcuts import render

from datetime import datetime, date

from .models import Friend



mhs_name = 'Nugraha Aktwovhiday'  

curr_year = int(datetime.now().strftime("%Y"))

birth_date = date(2002, 10, 2) 

npm = 2006596636 




def index(request):

    response = {'name': mhs_name,

                'age': calculate_age(birth_date.year),

                'npm': npm}

    return render(request, 'index_lab1.html', response)




def calculate_age(birth_year):

    return curr_year - birth_year if birth_year <= curr_year else 0




def friend_list(request):

    friends = Friend.objects.all().values()

    response = {'friends': friends}

    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.http.response import HttpResponse
from django.core import serializers
from django.shortcuts import render
from .models import Note

def index(request):
    notes = Note.objects.all().values()
    response = {'notes': notes}
    return render(request, 'lab2.html', response)

def xml(request):
    response = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(response, content_type='application/xml')

def json(request):
    response = serializers.serialize('json', Note.objects.all())
    return HttpResponse(response, content_type='application/json')

lab_3/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect
from .models import Friend
from .forms import FriendForm
from django.contrib.auth.decorators import login_required


@login_required(login_url="/admin/login/")
def index(request):
    friends = Friend.objects.all()
    response = {'friends': friends}
    return render(request, 'lab3_index.html', response)

@login_required(login_url="/admin/login/")
def add_friend(request):
    if request.method == 'POST':
        form = FriendForm(request.POST)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect('')  
    else:
        form = FriendForm()

    return render(request, 'lab3_form.html', {'form': form})

lab_4/views.py
from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect
from lab_4.forms import NoteForm
from .models import Note

def index(request):
    notes = Note.objects.all()
    response = {'notes': notes}
    return render(request, 'lab4_index.html', response)

def add_note(request):
    if request.method == "POST":
        form = NoteForm(request.POST)
        if form.is_valid():
            form.save()
    return render(request, 'lab4_form.html')

def note_list(request):
    notes = Note.objects.all()
    response = {'notes': notes}
    return render(request, 'lab4_note_list.html', response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      {% if friends %}
        {% for friend in friends %}
        <tr>
          <td>{{ friend.name }}</td>
          <td>{{ friend.npm }}</td>
          <td>{{ friend.dob }}</td>
        </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <style>
      table, td {
        border: 1px solid black;
      }
    </style>
    <meta charset="UTF-8" />
    <title>Note List</title>
  </head>
  <body>
    <h1>Note</h1>
    {% if notes %}
      {% for note in notes %}
      <table>
        <tr>
	  <td>To</td>
          <td>{{ note.to }}</td>
        </tr>
	<tr>
	  <td>From</td>
          <td>{{ note.froms }}</td>
        </tr>
	<tr>
          <td>Title</td>
          <td>{{ note.title }}</td>
        </tr>
	<tr>
	  <td>Message</td>
	  <td>{{ note.message }}</td>
        </tr>
      </table>
      <br>
      {% endfor %}
    {% endif %}
  </body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Add Friend</title>
  </head>
  <body>
    <form action="" method="POST">
      {% csrf_token %}
      {{ form }}
      <input type="submit" value="Submit">
    </form>
  </body>
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      {% if friends %}
        {% for friend in friends %}
        <tr>
          <td>{{ friend.name }}</td>
          <td>{{ friend.npm }}</td>
          <td>{{ friend.dob }}</td>
        </tr>
        {% endfor %}
      {% endif %}
    </table>
  </body>
</html>

lab_4/templates/lab4_form.html
{% extends 'base.html' %}
{% block content %}
<div class="container">
  <form action="{% url 'lab_4:add_note' %}" method="post">
    {% csrf_token %}
      <div class="mb-3">
        <label for="to" class="form-label">To</label>
          <input type="text" class="form-control" id="title" name="to">
      </div>
      <div class="mb-3">
        <label for="froms" class="form-label">From</label>
          <input type="text" class="form-control" id="title" name="froms">
      </div>
      <div class="mb-3">
        <label for="title" class="form-label">Title</label>
          <input type="text" class="form-control" id="title" name="title">
      </div>
      <div class="mb-3">
        <label for="message" class="form-label">Message</label>
          <input type="text" class="form-control" id="title" name="message">
      </div>
      <button type="submit" class="btn btn-primary">Submit</button>
  </form>
</div>
{% endblock content %}

lab_4/templates/lab4_index.html
{% extends 'base.html' %}
{% block content %}
<div class="container">
  <table class="table">
    <thead>
      <tr>
        <th scope="col">To</th>
        <th scope="col">From</th>
        <th scope="col">Title</th>
	<th scope="col">Message</th>
      </tr>
    </thead>
    <tbody>
      {% for note in notes %}
      <tr>
        <td>{{ note.to }}</td>
        <td>{{ note.froms }}</td>
        <td>{{ note.title }}</td>
	<td>{{ note.message }}</td>
      </tr>
      {% endfor %}
    </tbody>
  </table>
</div>
{% endblock content %}

lab_4/templates/lab4_note_list.html
{% extends 'base.html' %}
{% block content %}
<div class="container">
  <div class="row row-cols-1 row-cols-md-3 g-4">
  {% for note in notes %}
  <div class="col">
    <div class="card border-success mb-3" style="max-width: 18rem;">
      <div class="card-header bg-transparent border-success">{{ note.to }}</div>
      <div class="card-body text-success">
        <h5 class="card-title">{{ note.title }}</h5>
        <p class="card-text">{{ note.message }}</p>
      </div>
      <div class="card-footer bg-transparent border-success">{{ note.froms }}</div>
    </div>
  </div>
  {% endfor %}
  </div>
</div>
{% endblock content %}

templates/base.html
<!doctype html>
<html lang="en">
{% load static %}

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Bootstrap CSS -->
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">

  <title>Note</title>
</head>

<body>
  <nav class="navbar navbar-expand-lg navbar-light bg-light">
    <div class="container-fluid">
      <a class="navbar-brand" href="{% url 'lab_4:index' %}">
        <img src="{% static 'lab_4/images/notes.png' %}" height="32px" alt="">
      </a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent"
        aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav me-auto mb-2 mb-lg-0">
          <li class="nav-item">
            <a class="nav-link active" aria-current="page" href="{% url 'lab_4:index' %}">Note Table</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'lab_4:add_note' %}">Add Note</a>
          </li>
          <li class="nav-item">
            <a class="nav-link" href="{% url 'lab_4:note_list' %}">Note List</a>
          </li>
        </ul>
      </div>
    </div>
  </nav>
  {% block content %}

  {% endblock content %}

  <!-- Optional JavaScript; choose one of the two! -->

  <!-- Option 1: Bootstrap Bundle with Popper -->
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-/bQdsTh/da6pkI1MST/rWKFNjaCP5gBSY4sEBT38Q/9RBh9AH40zEOg7Hlq2THRZ"
    crossorigin="anonymous"></script>

  <!-- Option 2: Separate Popper and Bootstrap JS -->
  <!--
    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.3/dist/umd/popper.min.js" integrity="sha384-W8fXfP3gkOKtndU4JGtKDvXbO53Wy8SZCQHczT5FMiiqmQfUpWbYdTil/SxwZgAN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.min.js" integrity="sha384-skAcpIdS7UcVUC05LJ9Dxay8AXcDYfBJqt1CJ85S/CFujBsIzCIv+l9liuYLaMQ/" crossorigin="anonymous"></script>
    -->
</body>

</html>